#ifndef MARS_MCameraAUX
#define MARS_MCameraAUX

#ifndef MARS_MParContainer
#include "MParContainer.h"
#endif

class MCameraAUX : public MParContainer
{
    friend class MReportCamera;
private:
    Bool_t fRequestCaosLEDs; // Requested status: o=off, 1=on, bAux_CaOsLEDs_Off/On
    Bool_t fRequestFansFADC; // Requested status: o=off, 1=on, bAux_FADC_FANs_Off/On
    Bool_t fStatusCaosLEDs;  // Monitored status: o=off, 1=on, Cam.CaOs.LED_state
    Bool_t fStatusFansFADC;  // Monitored status: o=off, 1=on, Cam.FADC.Fans_state

public:
    MCameraAUX()
    {
        fName  = "MCameraAUX";
        fTitle = "Container storing information about the Camera auxiliary system";
    }

    Bool_t GetRequestCaosLEDs() const { return fRequestCaosLEDs; }
    Bool_t GetRequestFansFADC() const { return fRequestFansFADC; }
    Bool_t GetStatusCaosLEDs() const  { return fStatusCaosLEDs;  }
    Bool_t GetStatusFansFADC() const  { return fStatusFansFADC;  }

    ClassDef(MCameraAUX, 1) // Container storing information about the Camera auxiliary system
};

#endif
